#!/bin/bash

# Set the problem name to generate correct file names
PROBLEMNAME="numerology"

# Set this if you want to generate answers.
g++ -O2 ../../submissions/accepted/bjarki-dfs.cpp -o /tmp/a.out
#cp ../../submissions/accepted/solution.py /tmp/sol.py
SOLVER=/tmp/a.out
MAXN=200000
MAXD=200000
MAXT=200000

rm -f *_generated.{in,ans}

generate() {
    ((COUNT++))
    printf -v padCount "%02d" $COUNT
    ./gendata.py -s $COUNT -n $1 -t $2 -d $3 -o $4 > $DR/${padCount}_n$1_t$2_d$3_$4_generated.in
}

COUNT=0
generate 2 2 1 random
generate 2 4 3 random
generate 10 20 5 random
generate 100 200 50 random

COUNT=50
generate 2 $MAXT $MAXD random
generate 2 $MAXT $(($MAXD - 1)) random
generate 1000 2000 500 random
generate 1000 $MAXT 1000 random
generate 1000 $MAXT 10000 random
generate $MAXN $MAXT $MAXD random
generate $MAXN $MAXT 1 random
generate $(($MAXN / 2)) $MAXT $(($MAXD / 100)) random
generate $(($MAXN / 3)) $MAXT $(($MAXD / 2)) random
generate $(($MAXN / 3)) $MAXT $(($MAXD / 4)) random
generate $(($MAXN / 3)) $MAXT $(($MAXD / 16)) random
generate $(($MAXN / 3)) $MAXT $(($MAXD / 128)) random
generate $(($MAXN / 3)) $MAXT $(($MAXD / 1000)) random
generate $(($MAXN / 3)) $MAXT 10 random
generate $(($MAXN / 4)) $MAXT $(($MAXD / 2)) random
generate $(($MAXN / 4)) $MAXT $(($MAXD / 3)) random
generate $(($MAXN / 4)) $MAXT $(($MAXD / 4)) random
generate $(($MAXN / 4)) $MAXT $(($MAXD / 16)) random
generate $(($MAXN / 4)) $MAXT $(($MAXD / 64)) random
generate $(($MAXN / 4)) $MAXT 100 random
generate $(($MAXN / 4)) $MAXT 10 random
generate $(($MAXN / 4)) $MAXT 5 random
generate $(($MAXN / 2)) 0 0 line

# generate solutions for all files
if [[ ! -z $SOLVER ]]
then
    for f in *_generated.in
    do
        echo "solving $f"
        $SOLVER < $f > ${f%???}.ans
    done
fi
